import Generator, { GeneratorFeatures, GeneratorOptions, Question } from "yeoman-generator";
interface DependencyDefinition {
    name: string;
    comment: string;
    version?: string;
}
interface SubGeneratorCompositionConfig<T> {
    Generator: SubGeneratorConstructor<T>;
    path: string;
}
interface SubGeneratorConstructor<T> {
    new (args: string[], options: Partial<T> & GeneratorOptions, features?: GeneratorFeatures): BaseGenerator<T>;
    getQuestions?: () => Question<T>[];
}
export declare abstract class BaseGenerator<T extends Record<string, any> = Record<string, any>> extends Generator<Partial<T> & GeneratorOptions> {
    protected answers: T;
    private questions;
    constructor(args: string | string[], options: Partial<T> & GeneratorOptions, features?: GeneratorFeatures);
    composeWith(generators: any, options?: any, returnNewGenerator?: any): any;
    copyTemplate: (from: string, to: string, context?: Record<string, any>) => void;
    addDevDependencyWithComment(dependency: DependencyDefinition): Promise<void>;
    addDevDependenciesWithComments(dependencies: DependencyDefinition[]): Promise<void>;
    addDevDependencies(dependencies: string | string[] | Record<string, string>): Promise<Record<string, string>>;
    extendPackageJson(json: Record<string, any>): void;
    writeOrAppendGitignore(from: string): void;
    protected loadConfig(configFilePath: string): void;
    protected configureSubGenerators(): SubGeneratorCompositionConfig<any>[];
    protected exec(command: string): Promise<{
        stdout: string;
        stderr: string;
    }>;
    private initializeQuestions;
    private askQuestions;
    private initializeSubGenerators;
    private addQuestions;
    private addQuestionOrCopyOption;
    private composeWithSubGenerators;
    private writeOrAppendDestination;
    private writeOrAppend;
}
export {};
//# sourceMappingURL=BaseGenerator.d.ts.map