"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TestingGenerator = void 0;
const node_path_1 = __importDefault(require("node:path"));
const shared_1 = require("../shared");
const jest_1 = require("./jest");
const test_coverage_1 = require("./test-coverage");
class TestingGenerator extends shared_1.BaseGenerator {
    configureSubGenerators() {
        return [
            {
                Generator: jest_1.JestGenerator,
                path: node_path_1.default.join(__dirname, "./jest"),
            },
            {
                Generator: test_coverage_1.TestCoverageGenerator,
                path: node_path_1.default.join(__dirname, "./test-coverage"),
            },
        ];
    }
}
exports.TestingGenerator = TestingGenerator;
//# sourceMappingURL=TestingGenerator.js.map