"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypeScriptGenerator = void 0;
const node_path_1 = __importDefault(require("node:path"));
const shared_1 = require("../shared");
const tsconfig_1 = require("./tsconfig");
class TypeScriptGenerator extends shared_1.BaseGenerator {
    async writing() {
        this.copyTemplate("hello.ts", "src/hello.ts");
        await this.addDevDependencyWithComment({
            name: "typescript",
            comment: "TypeScript support for this project",
        });
    }
    configureSubGenerators() {
        return [
            {
                Generator: tsconfig_1.TsConfigGenerator,
                path: node_path_1.default.join(__dirname, "./tsconfig"),
            },
        ];
    }
}
exports.TypeScriptGenerator = TypeScriptGenerator;
//# sourceMappingURL=TypeScriptGenerator.js.map